## nano 6.1

=== debian/changelog ===
nano (6.1-1) unstable; urgency=medium

  * The "Remolacha" release.
  * New upstream release.
  * Sync debian/nanorc with upstream nanorc.sample.

 -- Jordi Mallach <jordi@debian.org>  Wed, 09 Feb 2022 12:45:28 +0100

nano (6.0-1) unstable; urgency=medium

  * The "Emérito" release.
  * New upstream release.
  * Add debian.nanorc as part of the packaging. Nano upstream has
    dropped it from the tarball due to its limited scope for users
    of Debian and derivatives. It'll be maintained here from now on.
  * Add support for mirror, s3 and in-toto APT transports.
  * Install out-of-tree syntax files in /usr/share/nano/debian.

 -- Jordi Mallach <jordi@debian.org>  Wed, 15 Dec 2021 16:41:06 +0100

nano (5.9-1) unstable; urgency=medium

  * The "Miquel Grau" release.
    - includes syntax highlighting rules for .yaml files (closes: #982091).
  * Sync debian/nanorc with upstream nanorc.sample.

 -- Jordi Mallach <jordi@debian.org>  Thu, 14 Oct 2021 16:21:27 +0200

nano (5.8-2) unstable; urgency=medium

  * The "Oficina del Español" release.
  * Update Standards-Version to 4.6.0.
  * Upload to unstable, now that ncurses can generate correct deps
    for nano-udeb.

 -- Jordi Mallach <jordi@debian.org>  Mon, 06 Sep 2021 15:01:19 +0200

nano (5.8-1) experimental; urgency=medium

  * The "mallorquín, menorquín, ibicenco y formenterés" release.
  * New upstream release.
  * Sync debian/nanorc with upstream nanorc.sample.
  * Bump debian/watch to version 4.

 -- Jordi Mallach <jordi@debian.org>  Mon, 16 Aug 2021 10:58:50 +0200

nano (5.7-1) experimental; urgency=medium

  * The "Más vale malo conocido" release.
  * New upstream release.

 -- Jordi Mallach <jordi@debian.org>  Thu, 06 May 2021 23:42:32 +0200

## nano 6.2

=== debian/changelog ===
nano (6.2-1) unstable; urgency=medium

  * The "Priviet" release.
  * New upstream release.

 -- Jordi Mallach <jordi@debian.org>  Sat, 19 Feb 2022 09:58:06 +0100

=== debian/control ===
Source: nano
Section: editors
Priority: optional
Maintainer: Jordi Mallach <jordi@debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>
Build-Depends: debhelper-compat (= 13),
               libncurses-dev,
               pkg-config,
               texinfo
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/debian/nano.git
Vcs-Browser: https://salsa.debian.org/debian/nano
Homepage: https://www.nano-editor.org/
Rules-Requires-Root: no

Package: nano
Architecture: any
Priority: important
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: hunspell
Breaks: nano-tiny (<< 2.8.6-2)
Conflicts: pico
Replaces: pico, nano-tiny (<< 2.8.6-2)
Description: small, friendly text editor inspired by Pico
 GNU nano is an easy-to-use text editor originally designed as a replacement
 for Pico, the ncurses-based editor from the non-free mailer package Pine
 (itself now available under the Apache License as Alpine).
 .
 However, GNU nano also implements many features missing in Pico, including:
  - undo/redo
  - line numbering
  - syntax coloring
  - soft-wrapping of overlong lines
  - selecting text by holding Shift
  - interactive search and replace (with regular expression support)
  - a go-to line (and column) command
  - support for multiple file buffers
  - auto-indentation
  - tab completion of filenames and search terms
  - toggling features while running
  - and full internationalization support

Package: nano-tiny
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: small, friendly text editor inspired by Pico - tiny build
 GNU nano is an easy-to-use text editor originally designed as a replacement
 for Pico, the ncurses-based editor from the non-free mailer package Pine
 (itself now available under the Apache License as Alpine).
 .
 This package contains a build of GNU nano with many features disabled, for
 environments such as rescue disks where resources are limited.

Package: nano-udeb
Architecture: any
Section: debian-installer
Priority: standard
Package-Type: udeb
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: small, friendly text editor inspired by Pico - udeb
 GNU nano is an easy-to-use text editor originally designed as a replacement
 for Pico, the ncurses-based editor from the non-free mailer package Pine
 (itself now available under the Apache License as Alpine).
 .
 This package contains a build of GNU nano with many features disabled, for
 use in debian-installer.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CFTINY  := -Os -fomit-frame-pointer
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  CFLAGS += -O0
endif

nanobuild=$(CURDIR)/build-nano
tinybuild=$(CURDIR)/build-tiny
udebbuild=$(CURDIR)/build-udeb

CONFFLAGS = \
	--bindir=/bin

CONFFLAGS_nano =

CONFFLAGS_tiny = \
	--enable-tiny \
	--without-included-regex \
	--disable-nls

CONFFLAGS_udeb = \
	--enable-tiny \
	--without-included-regex \
	--disable-nls

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --builddirectory=$(nanobuild) \
		-- $(CONFFLAGS) $(CONFFLAGS_nano)
	dh_auto_configure --builddirectory=$(tinybuild) \
		-- $(CONFFLAGS) $(CONFFLAGS_tiny) CFLAGS="$(CFLAGS) $(CFTINY)"
	dh_auto_configure --builddirectory=$(udebbuild) \
		-- $(CONFFLAGS) $(CONFFLAGS_udeb) CFLAGS="$(CFLAGS) $(CFTINY)"

override_dh_auto_build:
	dh_auto_build --builddirectory=$(nanobuild)
	dh_auto_build --builddirectory=$(tinybuild)
	dh_auto_build --builddirectory=$(udebbuild)

override_dh_auto_install:
	dh_auto_install --builddirectory=$(nanobuild) \
		--destdir=$(CURDIR)/debian/nano

	dh_auto_install --builddirectory=$(tinybuild) \
		--destdir=$(CURDIR)/debian/nano-tiny
	mv debian/nano-tiny/bin/nano debian/nano-tiny/bin/nano-tiny
	rm -rf $(CURDIR)/debian/nano-tiny/usr/share/man
	rm -rf $(CURDIR)/debian/nano-tiny/usr/share/info
	rm -rf $(CURDIR)/debian/nano-tiny/usr/share/nano
	rm -rf $(CURDIR)/debian/nano-tiny/usr/share/doc/nano
	rm -f $(CURDIR)/debian/nano-tiny/bin/rnano

	dh_auto_install --builddirectory=$(udebbuild) \
		--destdir=$(CURDIR)/debian/nano-udeb
	rm -rf $(CURDIR)/debian/nano-udeb/usr
	rm -f $(CURDIR)/debian/nano-udeb/bin/rnano

override_dh_auto_clean:
	dh_auto_clean --builddirectory=$(nanobuild)
	dh_auto_clean --builddirectory=$(tinybuild)
	dh_auto_clean --builddirectory=$(udebbuild)

## nano 6.2-1ubuntu0.1+11.0trisquel0

=== debian/changelog ===
nano (6.2-1ubuntu0.1+11.0trisquel0) aramo-security; urgency=medium

  * Rebuild upstream to get udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Thu, 21 Nov 2024 09:16:32 +0000

nano (6.2-1ubuntu0.1) jammy-security; urgency=medium

  * SECURITY UPDATE: Emergency file could be replaced by a malicious symlink.
    - debian/patches/CVE-2024-5742.patch: Use fchmod and fchown in write_file()
      in src/files.c instead of using chmod and chown in emergency_save() in
      src/nano.c. Add EMERGENCY write type in kind_of_writing_type enum in
      src/definitions.h. Update fd in write_file() in src/files.c. Based on
      upstream.
    - CVE-2024-5742

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Thu, 10 Oct 2024 11:09:30 -0230

## nano 6.2-1+11.0trisquel0

=== debian/changelog ===
nano (6.2-1+11.0trisquel0) aramo; urgency=medium

  * Rebuild upstream to get udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Fri, 14 Oct 2022 07:41:20 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: nano
 Section: editors
 Priority: optional
-Maintainer: Jordi Mallach <jordi@debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Uploaders: Steve Langasek <vorlon@debian.org>
 Build-Depends: debhelper-compat (= 13),
                libncurses-dev,

## nano 6.2-1+11.0trisquel1

=== debian/changelog ===
nano (6.2-1+11.0trisquel1) aramo; urgency=medium

  * Rebuild upstream to get udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 18 Feb 2025 03:08:53 +0000

nano (6.2-1+11.0trisquel1) aramo-security; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 18 Feb 2025 03:08:53 +0000

=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Section: editors
 Priority: optional
 Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
+XSBC-Original-Maintainer: Jordi Mallach <jordi@debian.org>
 Uploaders: Steve Langasek <vorlon@debian.org>
 Build-Depends: debhelper-compat (= 13),
                libncurses-dev,

## nano 6.3

=== debian/changelog ===
nano (6.3-1.0antix1) unstable; urgency=medium

  * New upstream release

 -- anticapitalista <antix@operamail.com>  Sun, 01 May 2022 13:04:42 +0300

nano (6.2-1.0antix1) unstable; urgency=medium

  * New upstream release 

 -- anticapitalista <antix@operamail.com>  Fri, 18 Feb 2022 13:09:34 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: nano
 Section: editors
 Priority: optional
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
-XSBC-Original-Maintainer: Jordi Mallach <jordi@debian.org>
+Maintainer: Jordi Mallach <jordi@debian.org>
 Uploaders: Steve Langasek <vorlon@debian.org>
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: debhelper-compat (= 12),
                libncurses-dev,
                pkg-config,
                texinfo

## nano 6.4

=== debian/changelog ===
nano (6.4-1) unstable; urgency=medium

  * New upstream release.
  * The "Explicaciones, ¿de qué? Jajaja" release.
  * Update Standards-Version to 4.6.1 (no changes needed).

 -- Jordi Mallach <jordi@debian.org>  Wed, 03 Aug 2022 12:35:51 +0200

nano (6.3-1) unstable; urgency=medium

  * The "Duque de Feria" release.
  * New upstream release.
  * Add support for the noudeb build profile.
  * Sync debian/nanorc with upstream nanorc.sample.

 -- Jordi Mallach <jordi@debian.org>  Tue, 03 May 2022 00:42:04 +0200

nano (5.4-2+deb11u1) bullseye; urgency=medium

  * The "Bueno, de verdad, hasta luego, paso" release.
  * Add additional patches from Benno Schulenberg with post 5.4
    crash, docs and general fixes.
  * Change debian-branch to bullseye.

 -- Jordi Mallach <jordi@debian.org>  Mon, 22 Nov 2021 01:07:23 +0100

## nano 7.0

=== debian/changelog ===
nano (7.0-1) unstable; urgency=medium

  * The "Cent anys de Joan Fuster" release.
  * New upstream release.
  * Update upstream signing key to 168E6F4297BFD7A79AFD4496514BBE2EB8E1961F.
  * Sync debian/nanorc with upstream nanorc.sample.
  * Update lintian source-overrides to silence false positives.

 -- Jordi Mallach <jordi@debian.org>  Wed, 23 Nov 2022 18:10:31 +0100

## nano 7.2

=== debian/changelog ===
nano (7.2-2build1) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:13:58 +0200

nano (7.2-2) unstable; urgency=medium

  [ Jordi Mallach ]
  * The "Pellets" release.
  * Fix a partial sync of debian/nanorc in the previous upload.
    This updates some example bindings to the new syntax, avoiding
    having control characters in the configuration file (closes: #1032422).
  * Build-Depend on pkgconf instead of pkg-config.
  * Update Standards-Version to 4.6.2, with no changes needed.

  [ Chris Hofstaedtler ]
  * Install all files below /usr. (Closes: #1059411)
    Keep update-alternatives calls unchanged to preserve user
    configuration.

 -- Jordi Mallach <jordi@debian.org>  Wed, 17 Jan 2024 01:35:55 +0100

nano (7.2-1) unstable; urgency=medium

  * The "Blue checkmark" release.
  * New upstream release.
  * Sync debian/nanorc with upstream nanorc.sample.
  * Update copyright years.

 -- Jordi Mallach <jordi@debian.org>  Wed, 18 Jan 2023 16:31:52 +0100

nano (7.1-1) unstable; urgency=medium

  * The "Home Petrov, si soc jo!" release.
  * New upstream release.
  * Update source lintian-overrides.

 -- Jordi Mallach <jordi@debian.org>  Wed, 14 Dec 2022 16:15:59 +0100

nano (5.4-2+deb11u2) bullseye; urgency=medium

  * The "No a l'ampliació del port" release.
  * Add three additional patches from Benno Schulenberg, with two
    crash fixes and one data-loss fix.

 -- Jordi Mallach <jordi@debian.org>  Fri, 02 Dec 2022 14:06:48 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: nano
 Section: editors
 Priority: optional
-Maintainer: Jordi Mallach <jordi@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Jordi Mallach <jordi@debian.org>
 Uploaders: Steve Langasek <vorlon@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libncurses-dev,
-               pkg-config,
+               pkgconf,
                texinfo
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/debian/nano.git
 Vcs-Browser: https://salsa.debian.org/debian/nano
 Homepage: https://www.nano-editor.org/
@@ -52,6 +53,7 @@
  environments such as rescue disks where resources are limited.
 
 Package: nano-udeb
+Build-Profiles: <!noudeb>
 Architecture: any
 Section: debian-installer
 Priority: standard

=== debian/rules ===
--- 
+++ 
@@ -13,8 +13,7 @@
 tinybuild=$(CURDIR)/build-tiny
 udebbuild=$(CURDIR)/build-udeb
 
-CONFFLAGS = \
-	--bindir=/bin
+CONFFLAGS =
 
 CONFFLAGS_nano =
 
@@ -36,13 +35,17 @@
 		-- $(CONFFLAGS) $(CONFFLAGS_nano)
 	dh_auto_configure --builddirectory=$(tinybuild) \
 		-- $(CONFFLAGS) $(CONFFLAGS_tiny) CFLAGS="$(CFLAGS) $(CFTINY)"
+ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
 	dh_auto_configure --builddirectory=$(udebbuild) \
 		-- $(CONFFLAGS) $(CONFFLAGS_udeb) CFLAGS="$(CFLAGS) $(CFTINY)"
+endif
 
 override_dh_auto_build:
 	dh_auto_build --builddirectory=$(nanobuild)
 	dh_auto_build --builddirectory=$(tinybuild)
+ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
 	dh_auto_build --builddirectory=$(udebbuild)
+endif
 
 override_dh_auto_install:
 	dh_auto_install --builddirectory=$(nanobuild) \
@@ -50,19 +53,23 @@
 
 	dh_auto_install --builddirectory=$(tinybuild) \
 		--destdir=$(CURDIR)/debian/nano-tiny
-	mv debian/nano-tiny/bin/nano debian/nano-tiny/bin/nano-tiny
+	mv debian/nano-tiny/usr/bin/nano debian/nano-tiny/usr/bin/nano-tiny
 	rm -rf $(CURDIR)/debian/nano-tiny/usr/share/man
 	rm -rf $(CURDIR)/debian/nano-tiny/usr/share/info
 	rm -rf $(CURDIR)/debian/nano-tiny/usr/share/nano
 	rm -rf $(CURDIR)/debian/nano-tiny/usr/share/doc/nano
-	rm -f $(CURDIR)/debian/nano-tiny/bin/rnano
+	rm -f $(CURDIR)/debian/nano-tiny/usr/bin/rnano
 
+ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
 	dh_auto_install --builddirectory=$(udebbuild) \
 		--destdir=$(CURDIR)/debian/nano-udeb
-	rm -rf $(CURDIR)/debian/nano-udeb/usr
-	rm -f $(CURDIR)/debian/nano-udeb/bin/rnano
+	rm -rf $(CURDIR)/debian/nano-udeb/usr/share
+	rm -f $(CURDIR)/debian/nano-udeb/usr/bin/rnano
+endif
 
 override_dh_auto_clean:
 	dh_auto_clean --builddirectory=$(nanobuild)
 	dh_auto_clean --builddirectory=$(tinybuild)
+ifeq (,$(filter noudeb,$(DEB_BUILD_PROFILES)))
 	dh_auto_clean --builddirectory=$(udebbuild)
+endif

## nano 7.2-2build1trisquel0

=== debian/changelog ===
nano (7.2-2build1trisquel0) ecne; urgency=medium

  * Rebuild upstream to get udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 09 Oct 2024 06:11:59 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: nano
 Section: editors
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 XSBC-Original-Maintainer: Jordi Mallach <jordi@debian.org>
 Uploaders: Steve Langasek <vorlon@debian.org>
 Build-Depends: debhelper-compat (= 13),

## nano 7.2-2ubuntu0.1trisquel0

=== debian/changelog ===
nano (7.2-2ubuntu0.1trisquel0) ecne-security; urgency=medium

  * Rebuild upstream to get udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 16 Oct 2024 07:09:29 +0000

nano (7.2-2ubuntu0.1) noble-security; urgency=medium

  * SECURITY UPDATE: Emergency file could be replaced by a malicious symlink.
    - debian/patches/CVE-2024-5742.patch: Use fchmod and fchown in write_file()
      in src/files.c instead of using chmod and chown in emergency_save() in
      src/nano.c. Add EMERGENCY write type in kind_of_writing_type enum in
      src/definitions.h. Update fd in write_file() in src/files.c. Based on
      upstream.
    - CVE-2024-5742

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Thu, 10 Oct 2024 13:44:07 -0230

## nano 8.0

=== debian/changelog ===
nano (8.0-1) unstable; urgency=medium

  * The "Gaza" release.
  * New upstream release.
  * Rename debian and upstream branches to adhere to DEP14.
  * Update Standards-Version to 4.7.0, with no changes needed.
  * Avoid running autopoint during dh_autoreconf.
  * Sync debian/nanorc with upstream nanorc.sample.
  * Update copyright years.

 -- Jordi Mallach <jordi@debian.org>  Mon, 06 May 2024 23:48:31 +0200

## nano 8.1

=== debian/changelog ===
nano (8.1-1) unstable; urgency=medium

  * The "Hem sigut feliços, 🐵" release.
  * New upstream release.
  * Sync debian/nanorc with upstream nanorc.sample.
  * Set "colonparsing` in system nanorc, to retain "filename:linenumber"
    functionality by default.

 -- Jordi Mallach <jordi@debian.org>  Tue, 16 Jul 2024 00:25:35 +0200

## nano 8.2

=== debian/changelog ===
nano (8.2-1) unstable; urgency=medium

  * The "La Regata de Jaume" release.
  * New upstream release.
  * Add nano and nano-tiny lintian overrides for /bin → /usr/bin mismatch,
    as update-alternatives calls should not be updated to the usrmerged paths.

 -- Jordi Mallach <jordi@debian.org>  Sat, 28 Sep 2024 01:57:23 +0200

## nano 8.3

=== debian/changelog ===
nano (8.3-1) unstable; urgency=medium

  * The "Mazón dimissió" release.
  * New upstream release.
  * Sync debian/nanorc with upstream nanorc.sample.

 -- Jordi Mallach <jordi@debian.org>  Mon, 06 Jan 2025 19:08:18 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: nano
 Section: editors
 Priority: optional
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
-XSBC-Original-Maintainer: Jordi Mallach <jordi@debian.org>
+Maintainer: Jordi Mallach <jordi@debian.org>
 Uploaders: Steve Langasek <vorlon@debian.org>
 Build-Depends: debhelper-compat (= 13),
                libncurses-dev,
                pkgconf,
                texinfo
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/debian/nano.git
 Vcs-Browser: https://salsa.debian.org/debian/nano
 Homepage: https://www.nano-editor.org/

## nano 8.4

=== debian/changelog ===
nano (8.4-1) unstable; urgency=medium

  * The "Steve Langasek" release. Thanks for your help, for the
    chats, for the moments shared, for being such an incredible person.
    You will be missed.
  * Remove Steve from Uploaders.
  * New upstream release.
    - includes test-groff fixes from Bjarni Ingi Gislason to nano manpages.
      (closes: #1095957).
  * Sync debian/nanorc with upstream nanorc.sample.
  * Update Standards-Version to 4.7.2.

 -- Jordi Mallach <jordi@debian.org>  Sun, 06 Apr 2025 16:11:52 +0200

## nano 8.5

=== debian/changelog ===
nano (8.5-1) unstable; urgency=medium

  * The "Anas al-Sharif" release.
  * New upstream release.
  * Sync debian/nanorc with upstream nanorc.sample.
  * Update copyright years.
  * Don't refer to old FSF postal address.

 -- Jordi Mallach <jordi@debian.org>  Mon, 18 Aug 2025 22:15:49 +0200

## nano 8.6

=== debian/changelog ===
nano (8.6-1) unstable; urgency=medium

  * The "Awdah Hathaleen" release.
  * New upstream release.
  * Update lintian overrides.

 -- Jordi Mallach <jordi@debian.org>  Fri, 22 Aug 2025 12:33:43 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,11 @@
 Section: editors
 Priority: optional
 Maintainer: Jordi Mallach <jordi@debian.org>
-Uploaders: Steve Langasek <vorlon@debian.org>
 Build-Depends: debhelper-compat (= 13),
                libncurses-dev,
                pkgconf,
                texinfo
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/debian/nano.git
 Vcs-Browser: https://salsa.debian.org/debian/nano
 Homepage: https://www.nano-editor.org/

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,9 @@
 #export DH_VERBOSE=1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+# Avoid dh_autoreconf from failing due to running autopoint
+export AUTOPOINT = true
 
 CFTINY  := -Os -fomit-frame-pointer
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.asc/" \
https://nano-editor.org/dist/v(\d)+/nano-([\d\.]+)\.tar\.xz

## nano 8.7

=== debian/changelog ===
nano (8.7-1) unstable; urgency=medium

  * The "Aysam Mualla" release.
  * New upstream release.
  * Use version 5 of watch file.
  * Sync debian/nanorc with upstream nanorc.sample.
  * Drop now redundant Rules-Requires-Root control field.

 -- Jordi Mallach <jordi@debian.org>  Fri, 21 Nov 2025 00:18:13 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,6 @@
 Vcs-Git: https://salsa.debian.org/debian/nano.git
 Vcs-Browser: https://salsa.debian.org/debian/nano
 Homepage: https://www.nano-editor.org/
-Rules-Requires-Root: no
 
 Package: nano
 Architecture: any

=== debian/watch ===
Version: 5
Source: https://nano-editor.org/dist/@ANY_VERSION@/
Matching-Pattern: @PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
Pgp-Sig-Url-Mangle: s/$/.asc/

## nano 8.7.1

=== debian/changelog ===
nano (8.7.1-1) unstable; urgency=medium

  * The "Yellow Line" release.
  * New upstream release.
  * Drop redundant Priority field for source package.

 -- Jordi Mallach <jordi@debian.org>  Sun, 08 Feb 2026 23:29:41 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: nano
 Section: editors
-Priority: optional
 Maintainer: Jordi Mallach <jordi@debian.org>
 Build-Depends: debhelper-compat (= 13),
                libncurses-dev,

## nano banana-0.3.0

=== Makefile ===
# Nano Banana Package - UV 极速工作流 🍌⚡
# 基于 Gemini 2.5 Flash Image 的图像生成和分析包

.PHONY: sync test build publish clean dev format lint check release

# 🚀 初始化项目 (仅需运行一次)
init:
	@echo "🎉 使用 uv 初始化 nano-banana 项目..."
	uv sync
	@echo "✅ 项目初始化完成！"

# 📦 同步依赖 (超快速度)
sync:
	@echo "⚡ 同步依赖..."
	uv sync

# 🧪 运行测试 (UV 环境)
test:
	@echo "🧪 运行 nano-banana 测试..."
	uv run python tests/simple_test.py
	uv run python tests/quick_test.py
	uv run python tests/nano_banana_test.py
	@echo "🧪 运行 pytest..."
	uv run pytest tests/ -v

# 🚀 开发模式测试
dev:
	@echo "🚀 开发模式测试..."
	uv run python -c "import nano_banana as nb; print('✅ 导入成功')"
	uv run python -c "from nano_banana import NanoBanana; client = NanoBanana(); print('✅ 客户端创建成功')"
	@echo "💡 提示：请确保已设置 SIMEN_AI_API_KEY 或 OPENAI_API_KEY 环境变量"

# 🔨 构建包 (UV 原生构建)
build:
	@echo "🔨 使用 uv 构建 nano-banana 包..."
	uv build

# 🧪 发布到 TestPyPI (UV 原生)
test-publish:
	@echo "🧪 发布到 TestPyPI..."
	@echo "💡 需要设置环境变量: export UV_PUBLISH_TOKEN=your-testpypi-token"
	uv publish --token $$UV_PUBLISH_TOKEN --repository testpypi

# 🚀 发布到 PyPI (UV 原生)
publish:
	@echo "🚀 发布到 PyPI..."
	@echo "💡 需要设置环境变量: export UV_PUBLISH_TOKEN=your-pypi-token"
	uv publish --token $$UV_PUBLISH_TOKEN

# 🏢 发布到私有仓库
publish-private:
	@echo "🏢 发布到私有仓库..."
	uv publish --repository-url http://your-private-pypi.com/simple/

# 🧹 清理构建文件
clean:
	@echo "🧹 清理构建文件..."
	rm -rf build/
	rm -rf dist/
	rm -rf *.egg-info/
	rm -rf .uv_cache/
	find . -type d -name __pycache__ -delete
	find . -type f -name "*.pyc" -delete

# 📊 代码质量检查
lint:
	@echo "📊 代码质量检查..."
	uv run ruff check src/
	uv run mypy src/nano_banana/

# 🎨 代码格式化
format:
	@echo "🎨 代码格式化..."
	uv run ruff format src/

# ✅ 完整检查
check: lint test
	@echo "✅ 所有检查通过！"

# 🎉 完整发布流程 (极速版)
release: clean check build test-publish
	@echo "🎉 版本发布完成! 检查 TestPyPI 后运行 'make publish' 发布到正式 PyPI"

# ⚡ 添加依赖 (示例)
add-dep:
	@echo "示例: uv add openai"
	@echo "示例: uv add --dev pytest"
	@echo "示例: uv add --dev ruff"

# 🔄 更新所有依赖
update:
	@echo "🔄 更新所有依赖..."
	uv sync --upgrade

# 📋 显示依赖树
tree:
	@echo "📋 依赖树..."
	uv tree

# 🎯 快速开始 (新开发者)
quickstart: init test dev
	@echo "🎯 快速开始完成！可以开始开发了"

# 📄 运行示例脚本
examples:
	@echo "🎯 运行 nano-banana 示例..."
	@echo "1️⃣ 文本生成图片测试:"
	uv run tests/text_to_image_test.py
	@echo "\n2️⃣ 图片到图片测试:"
	uv run tests/image_to_image_test.py
	@echo "\n3️⃣ 图片分析测试:"
	uv run tests/simple_test.py

# 🔧 设置发布认证
setup-auth:
	@echo "🔧 设置发布认证..."
	@echo "1. 获取 PyPI API Token: https://pypi.org/manage/account/token/"
	@echo "2. 获取 TestPyPI API Token: https://test.pypi.org/manage/account/token/"
	@echo "3. 设置环境变量:"
	@echo "   export UV_PUBLISH_TOKEN=your-pypi-token"
	@echo "4. 然后运行: make test-publish 或 make publish"

# 🍌 nano-banana 专用命令

# 🎨 测试文本生成图片
test-text2img:
	@echo "🎨 测试文本生成图片功能..."
	uv run python -c "import nano_banana as nb; result = nb.text_to_image('一只可爱的橙色小猫'); print('生成结果:', result[:100] + '...')"

# 🔍 测试图片分析
test-analyze:
	@echo "🔍 测试图片分析功能..."
	uv run python tests/simple_test.py

# 🔄 测试图片到图片
test-img2img:
	@echo "🔄 测试图片到图片功能..."
	uv run python tests/image_to_image_test.py

# 🌐 检查环境变量
check-env:
	@echo "🌐 检查环境变量配置..."
	@if [ -z "$$SIMEN_AI_API_KEY" ] && [ -z "$$OPENAI_API_KEY" ]; then \
		echo "❌ 未设置 API 密钥！"; \
		echo "请设置以下环境变量之一:"; \
		echo "  export SIMEN_AI_API_KEY=your-simen-key"; \
		echo "  export OPENAI_API_KEY=your-openai-key"; \
	else \
		echo "✅ API 密钥已配置"; \
	fi
	@if [ -n "$$SIMEN_BASEURL" ]; then \
		echo "✅ SIMEN_BASEURL: $$SIMEN_BASEURL"; \
	else \
		echo "💡 可选：设置 SIMEN_BASEURL=https://api.simen.ai/v1"; \
	fi

# 🎉 完整功能测试
test-all: check-env test-text2img test-analyze test-img2img
	@echo "🎉 所有功能测试完成！"

# 📚 显示帮助信息
help:
	@echo "🍌 Nano Banana Makefile 命令帮助"
	@echo ""
	@echo "📦 项目管理:"
	@echo "  init          - 初始化项目"
	@echo "  sync          - 同步依赖"
	@echo "  clean         - 清理构建文件"
	@echo ""
	@echo "🧪 开发测试:"
	@echo "  dev           - 开发模式测试"
	@echo "  test          - 运行所有测试"
	@echo "  check-env     - 检查环境变量"
	@echo "  test-all      - 完整功能测试"
	@echo ""
	@echo "🍌 nano-banana 专用:"
	@echo "  test-text2img - 测试文本生成图片"
	@echo "  test-analyze  - 测试图片分析"
	@echo "  test-img2img  - 测试图片到图片"
	@echo ""
	@echo "🔨 构建发布:"
	@echo "  build         - 构建包"
	@echo "  test-publish  - 发布到 TestPyPI"
	@echo "  publish       - 发布到 PyPI"
	@echo "  release       - 完整发布流程"
	@echo ""
	@echo "💡 使用示例："
	@echo "  make quickstart  # 快速开始"
	@echo "  make test-all    # 测试所有功能"
	@echo "  make release     # 发布新版本"

## nano banana-0.4.2

=== Makefile ===
.PHONY: test build clean install publish test-publish

# 🧪 测试
test:
	uv run tests/simple_test.py

# 🔨 构建
build:
	uv build

# 🧹 清理
clean:
	rm -rf build/ dist/ *.egg-info/
	find . -type d -name __pycache__ -delete

# 📦 安装
install:
	uv sync

# 🧪 发布到 TestPyPI
test-publish: clean build
	uv publish --repository testpypi

# 🚀 发布到 PyPI
publish: clean build
	uv publish

## nano fmm-0.1.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15...3.26)

# https://scikit-build-core.readthedocs.io/en/latest/cmakelists.html#accessing-information
project(
  ${SKBUILD_PROJECT_NAME}
  VERSION ${SKBUILD_PROJECT_VERSION}
  LANGUAGES CXX)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 17)

# TODO add_definitions(-DNANO_FMM_DISABLE_UNORDERED_DENSE=0)

if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
endif()
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
endif()

# set(CMAKE_BUILD_TYPE "Debug")

if(NOT CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")
  set(CMAKE_BUILD_TYPE
      "Release"
      CACHE STRING "" FORCE)
  message(STATUS "Set build type to default: ${CMAKE_BUILD_TYPE}")
else()
  message(STATUS "Your build type: ${CMAKE_BUILD_TYPE}")
endif()
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O0 -ggdb")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -ggdb")
  add_definitions(-DSPDLOG_ACTIVE_LEVEL=SPDLOG_LEVEL_TRACE)
elseif(CMAKE_BUILD_TYPE STREQUAL "Release")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O3")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
endif()

# TODO, use set(PYBIND11_NEWPYTHON ON)?
# https://scikit-build-core.readthedocs.io/en/latest/getting_started.html
find_package(Python REQUIRED COMPONENTS Interpreter Development.Module)
find_package(pybind11 CONFIG REQUIRED)

include_directories(3rdparty src)
file(GLOB_RECURSE SRCS src/*.cpp)
python_add_library(_core MODULE ${SRCS} WITH_SOABI)
target_link_libraries(_core PRIVATE pybind11::headers)
target_include_directories(_core PRIVATE src)

option(BUILD_EXAMPLES "Build examples" OFF)
if(BUILD_EXAMPLES)
  file(GLOB SRCS examples/*.cpp)
  foreach(src ${SRCS})
    string(REGEX REPLACE "(^.*/|.cpp$)" "" exe ${src})
    add_executable(${exe} ${src})
    install(TARGETS ${exe} RUNTIME DESTINATION bin)
  endforeach(src)
endif()

target_compile_definitions(_core PRIVATE VERSION_INFO=${PROJECT_VERSION})
install(TARGETS _core DESTINATION nano_fmm)

=== Makefile ===
PROJECT_SOURCE_DIR ?= $(abspath ./)
PROJECT_NAME ?= $(shell basename $(PROJECT_SOURCE_DIR))
NUM_JOBS ?= 8

all:
	@echo nothing special

clean:
	rm -rf build dist site wheelhouse *.egg-info
force_clean:
	docker run --rm -v `pwd`:`pwd` -w `pwd` -it alpine/make make clean
.PHONY: clean force_clean

data_clean:
	make -C data clean
data_pull:
	make -C data pull

lint:
	pre-commit run -a
lint_install:
	pre-commit install

docs_build:
	python3 -m pip install -r docs/requirements.txt
	mkdocs build
docs_serve:
	python3 -m pip install -r docs/requirements.txt
	mkdocs serve -a 0.0.0.0:8088

DOCKER_TAG_WINDOWS ?= ghcr.io/cubao/build-env-windows-x64:v0.0.1
DOCKER_TAG_LINUX ?= ghcr.io/cubao/build-env-manylinux2014-x64:v0.0.4
DOCKER_TAG_MACOS ?= ghcr.io/cubao/build-env-macos-arm64:v0.0.1

test_in_win:
	docker run --rm -w `pwd` -v `pwd`:`pwd` -v `pwd`/build/win:`pwd`/build -it $(DOCKER_TAG_WINDOWS) bash
test_in_mac:
	docker run --rm -w `pwd` -v `pwd`:`pwd` -v `pwd`/build/mac:`pwd`/build -it $(DOCKER_TAG_MACOS) bash
test_in_linux:
	docker run --rm -w `pwd` -v `pwd`:`pwd` -v `pwd`/build/linux:`pwd`/build -it $(DOCKER_TAG_LINUX) bash

DEV_CONTAINER_NAME ?= $(USER)_$(subst /,_,$(PROJECT_NAME)____$(PROJECT_SOURCE_DIR))
DEV_CONTAINER_IMAG ?= $(DOCKER_TAG_LINUX)
test_in_dev_container:
	docker ps | grep $(DEV_CONTAINER_NAME) \
		&& docker exec -it $(DEV_CONTAINER_NAME) bash \
		|| docker run --rm --name $(DEV_CONTAINER_NAME) \
			--network host --security-opt seccomp=unconfined \
			-v `pwd`:`pwd` -w `pwd` -it $(DEV_CONTAINER_IMAG) bash

PYTHON ?= python3
build:
	$(PYTHON) -m pip install scikit_build_core pyproject_metadata pathspec pybind11
	CMAKE_BUILD_PARALLEL_LEVEL=$(NUM_JOBS) $(PYTHON) -m pip install --no-build-isolation -Ceditable.rebuild=true -Cbuild-dir=build -ve.
python_install:
	$(PYTHON) -m pip install . --verbose
python_wheel:
	$(PYTHON) -m pip wheel . -w build --verbose
python_sdist:
	$(PYTHON) -m pip sdist . --verbose
python_test:
	$(PYTHON) -c 'import nano_fmm; print(nano_fmm.add(1, 2))'
	$(PYTHON) -m nano_fmm add 1 2
	$(PYTHON) -m nano_fmm pure_python_func --arg1=43234
	python3 -m pip install pytest
	pytest tests
.PHONY: build

# conda create -y -n py36 python=3.6
# conda create -y -n py37 python=3.7
# conda create -y -n py38 python=3.8
# conda create -y -n py39 python=3.9
# conda create -y -n py310 python=3.10
# conda create -y -n py311 python=3.11
# conda env list
python_build_py36:
	PYTHON=python conda run --no-capture-output -n py36 make python_build
python_build_py37:
	PYTHON=python conda run --no-capture-output -n py37 make python_build
python_build_py38:
	PYTHON=python conda run --no-capture-output -n py38 make python_build
python_build_py39:
	PYTHON=python conda run --no-capture-output -n py39 make python_build
python_build_py310:
	PYTHON=python conda run --no-capture-output -n py310 make python_build
python_build_py311:
	PYTHON=python conda run --no-capture-output -n py311 make python_build
python_build_all: python_build_py36 python_build_py37 python_build_py38 python_build_py39 python_build_py310 python_build_py311
python_build_all_in_linux:
	docker run --rm -w `pwd` -v `pwd`:`pwd` -v `pwd`/build/linux:`pwd`/build -it $(DOCKER_TAG_LINUX) make python_build_all repair_wheels
	make repair_wheels && rm -rf dist/*.whl && mv wheelhouse/*.whl dist && rm -rf wheelhouse
python_build_all_in_macos: python_build_py38 python_build_py39 python_build_py310 python_build_py311
python_build_all_in_windows: python_build_all

repair_wheels:
	python -m pip install auditwheel # sudo apt install patchelf
	ls dist/*-linux_x86_64.whl | xargs -n1 auditwheel repair --plat manylinux2014_x86_64
	rm -rf dist/*-linux_x86_64.whl && cp wheelhouse/*.whl dist && rm -rf wheelhouse

pypi_remote ?= pypi
upload_wheels:
	python -m pip install twine
	twine upload dist/*.whl -r $(pypi_remote)

tar.gz:
	tar -cvz --exclude .git -f ../$(PROJECT_NAME).tar.gz .
	ls -alh ../$(PROJECT_NAME).tar.gz

# https://stackoverflow.com/a/25817631
echo-%  : ; @echo -n $($*)
Echo-%  : ; @echo $($*)
ECHO-%  : ; @echo $* = $($*)
echo-Tab: ; @echo -n '    '

=== data/Makefile ===
# migrated from https://github.com/cubao/cpp-example/blob/main/data/Makefile

# this file keeps track of testing data used by this project.
# all files should be stored somewhere with overwrite protection.
# so these download links 100% guarantee exatly same files across time.

all:
	@echo use "make pull" to pull data
	@echo use "make clean" to clean data

.PHONY: all pull clean
clean:
	@find . -maxdepth 1 ! -name Makefile ! -name . ! -name .. -exec rm -rf {} +

# https://github.com/cubao/fmm/wiki/Sample-data
pull: network.json
network.json: | network.zip
	unzip network.zip
network.zip:
	curl -LO https://github.com/cubao/fmm/files/11698908/network.zip

pull: suzhoubeizhan.json
suzhoubeizhan.json: | suzhoubeizhan.zip
	unzip suzhoubeizhan.zip
suzhoubeizhan.zip:
	curl -LO https://github.com/cubao/fmm/files/12568463/suzhoubeizhan.zip

=== docs/requirements.txt ===
mkdocs==1.5.2
mkdocs-include-markdown-plugin==4.0.3
mkdocs-material==9.1.21
mkdocs-material-extensions==1.1.1
